Coin: SoMultiTextureCoordinateElement Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

Classes | Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
SoMultiTextureCoordinateElement Class Reference
Element Classes

The SoMultiTextureCoordinateElement class is yet to be documented. More...

`#include <Inventor/elements/SoMultiTextureCoordinateElement.h>`

Inheritance diagram for SoMultiTextureCoordinateElement:

## Classes
class | UnitData

## Public Types
enum | CoordType { NONE = 0 , TEXGEN = 0 , EXPLICIT = 1 , FUNCTION = 2 , DEFAULT = 3 }

## Public Member Functions
virtual void | init (SoState *state)
| FIXME: write doc.
virtual CoordType | getType (const int unit=0) const
| FIXME: write doc.
const SbVec4f & | get (const int unit, const SbVec3f &point, const SbVec3f &normal) const
int32_t | getNum (const int unit=0) const
| FIXME: write doc.
SbBool | is2D (const int unit=0) const
| FIXME: write doc. (for backwards compatibility. Use getDimension() instead).
int32_t | getDimension (const int unit=0) const
const SbVec2f & | get2 (const int unit, const int index) const
| FIXME: write doc.
const SbVec3f & | get3 (const int unit, const int index) const
const SbVec4f & | get4 (const int unit, const int index) const
| FIXME: write doc.
const SbVec2f * | getArrayPtr2 (const int unit=0) const
const SbVec3f * | getArrayPtr3 (const int unit=0) const
const SbVec4f * | getArrayPtr4 (const int unit=0) const
virtual void | push (SoState *state)
virtual SbBool | matches (const SoElement *elem) const
SoElement * | copyMatchInfo (void) const
const SbVec4f & | get (const SbVec3f &point, const SbVec3f &normal) const
const SbVec2f & | get2 (const int index) const
const SbVec3f & | get3 (const int index) const
const SbVec4f & | get4 (const int index) const
Public Member Functions inherited from SoElement
const SoType | getTypeId (void) const
int | getStackIndex (void) const
virtual void | pop (SoState *state, const SoElement *prevTopElement)
void | setDepth (const int depth)
int | getDepth (void) const
virtual void | print (FILE *file=stdout) const
virtual | ~SoElement ()

## Static Public Member Functions
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void * | createInstance (void)
static void | initClass (void)
static void | setDefault (SoState *const state, SoNode *const node, const int unit=0)
| FIXME: write doc.
static void | setFunction (SoState *const state, SoNode *const node, const int unit, SoTextureCoordinateFunctionCB *const func, void *const userdata)
| FIXME: write doc.
static void | set2 (SoState *const state, SoNode *const node, const int unit, const int32_t numCoords, const SbVec2f *const coords)
| FIXME: write doc.
static void | set3 (SoState *const state, SoNode *const node, const int unit, const int32_t numCoords, const SbVec3f *const coords)
static void | set4 (SoState *const state, SoNode *const node, const int unit, const int32_t numCoords, const SbVec4f *const coords)
| FIXME: write doc.
static CoordType | getType (SoState *const state, const int unit=0)
static const SoMultiTextureCoordinateElement * | getInstance (SoState *const state)
| FIXME: write doc.
static void | setFunction (SoState *const state, SoNode *const node, SoTextureCoordinateFunctionCB *const func, void *const userdata)
static void | set2 (SoState *const state, SoNode *const node, const int32_t numCoords, const SbVec2f *const coords)
static void | set3 (SoState *const state, SoNode *const node, const int32_t numCoords, const SbVec3f *const coords)
static void | set4 (SoState *const state, SoNode *const node, const int32_t numCoords, const SbVec4f *const coords)
Static Public Member Functions inherited from SoElement
static void | initClass (void)
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void | initElements (void)
static int | getNumStackIndices (void)
static SoType | getIdFromStackIndex (const int stackIndex)

## Protected Member Functions
| SoMultiTextureCoordinateElement (void)
virtual | ~SoMultiTextureCoordinateElement ()
int | getMaxUnits () const
UnitData & | getUnitData (const int unit)
const UnitData & | getUnitData (const int unit) const
Protected Member Functions inherited from SoElement
| SoElement (void)
void | capture (SoState *const state) const
virtual void | captureThis (SoState *state) const
void | setTypeId (const SoType typeId)
void | setStackIndex (const int index)
SoElement * | getNextInStack (void) const
SoElement * | getNextFree (void) const

## Protected Attributes
SbVec2f | convert2
SbVec3f | convert3
SbVec4f | convert4
Protected Attributes inherited from SoElement
SoType | typeId
int | stackIndex
int | depth

## Additional Inherited Members
Static Protected Member Functions inherited from SoElement
static SoElement * | getElement (SoState *const state, const int stackIndex)
static const SoElement * | getConstElement (SoState *const state, const int stackIndex)
static int | createStackIndex (const SoType id)
Static Protected Attributes inherited from SoElement
static int | classStackIndex
static SoTypeList * | stackToType

## Detailed Description

The SoMultiTextureCoordinateElement class is yet to be documented.

FIXME: write doc.

Be aware that this class is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since
  Coin 2.2

## Constructor & Destructor Documentation

## ◆ SoMultiTextureCoordinateElement()

SoMultiTextureCoordinateElement::SoMultiTextureCoordinateElement | ( | void |  | ) |
| protected

Constructor.

## ◆ ~SoMultiTextureCoordinateElement()

SoMultiTextureCoordinateElement::~SoMultiTextureCoordinateElement | ( |  | ) |
| protectedvirtual

Destructor.

## Member Function Documentation

## ◆ getClassTypeId()

SoType SoMultiTextureCoordinateElement::getClassTypeId | ( | void |  | ) |
| static

This static method returns the SoType object associated with objects of this class.

## ◆ getClassStackIndex()

int SoMultiTextureCoordinateElement::getClassStackIndex | ( | void |  | ) |
| static

This static method returns the state stack index for the class.

## ◆ createInstance()

void * SoMultiTextureCoordinateElement::createInstance | ( | void |  | ) |
| static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Creates a new instance of the class type corresponding to the SoType object.

## ◆ initClass()

void SoMultiTextureCoordinateElement::initClass | ( | void |  | ) |
| static

Initialize relevant common data for all instances, like the type system.

## ◆ init()

void SoMultiTextureCoordinateElement::init | ( | SoState * | state | ) |
| virtual

FIXME: write doc.

Reimplemented from SoElement.

Reimplemented in SoGLMultiTextureCoordinateElement.

## ◆ set3()

void SoMultiTextureCoordinateElement::set3 | ( | SoState *const | state,
|  | SoNode *const | node,
|  | const int | unit,
|  | const int32_t | numCoords,
|  | const SbVec3f *const | coords )
| static

FIXME: write doc.

## ◆ getType() [1/2]

SoMultiTextureCoordinateElement::CoordType SoMultiTextureCoordinateElement::getType | ( | SoState *const | state,
|  | const int | unit = 0 )
| static

This method is used by shapes. Three return values are possible.

DEFAULT means that the shapes should generate their own texture coordinates.

EXPLICIT means that discrete texture coordinates are stored, and should be fetched with get2(), get3() or get4().

FUNCTION means that get(point, normal) must be used to generate texture coordinates.

## ◆ getType() [2/2]

SoMultiTextureCoordinateElement::CoordType SoMultiTextureCoordinateElement::getType | ( | const int | unit = 0 | ) | const
| virtual

FIXME: write doc.

Reimplemented in SoGLMultiTextureCoordinateElement.

## ◆ get()

const SbVec4f & SoMultiTextureCoordinateElement::get | ( | const int | unit,
|  | const SbVec3f & | point,
|  | const SbVec3f & | normal ) const

This method returns texture coordinate for the given point and normal. The coordinate is returned as a 4D vector where the r and q coordinates may be set to 0 and 1 respectively depending on what texture coordinate dimension we're using.

This method should only be used if the CoordType is FUNCTION.

## ◆ getDimension()

int32_t SoMultiTextureCoordinateElement::getDimension | ( | const int | unit = 0 | ) | const

FIXME: write doc.

## ◆ get3()

const SbVec3f & SoMultiTextureCoordinateElement::get3 | ( | const int | unit,
|  | const int | index ) const

FIXME: write doc.

## ◆ getArrayPtr2()

const SbVec2f * SoMultiTextureCoordinateElement::getArrayPtr2 | ( | const int | unit = 0 | ) | const

Returns a pointer to the 2D texture coordinate array. This method is not part of the OIV API.

## ◆ getArrayPtr3()

const SbVec3f * SoMultiTextureCoordinateElement::getArrayPtr3 | ( | const int | unit = 0 | ) | const

Returns a pointer to the 3D texture coordinate array.

## ◆ getArrayPtr4()

const SbVec4f * SoMultiTextureCoordinateElement::getArrayPtr4 | ( | const int | unit = 0 | ) | const

Returns a pointer to the 4D texture coordinate array. This method is not part of the OIV API.

## ◆ push()

void SoMultiTextureCoordinateElement::push | ( | SoState * | state | ) |
| virtual

This method is called every time a new element is required in one of the stacks. This happens when a writable element is requested, using SoState::getElement() or indirectly SoElement::getElement(), and the depth of the current element is less than the state depth.

Override this method if your element needs to copy data from the previous top of stack. The push() method is called on the new element, and the previous element can be found using SoElement::getNextInStack().

Reimplemented from SoElement.

Reimplemented in SoGLMultiTextureCoordinateElement.

## ◆ matches()

SbBool SoMultiTextureCoordinateElement::matches | ( | const SoElement * | element | ) | const
| virtual

This function returns `TRUE` is the element matches another element (of the same class), with respect to cache validity.

If the application programmer's extension element has a matches() function, it should also have a copyMatchInfo() function.

Implements SoElement.

## ◆ copyMatchInfo()

SoElement * SoMultiTextureCoordinateElement::copyMatchInfo | ( | void |  | ) | const
| virtual

This function creates a copy of the element that contains enough information to enable the matches() function to work.

Used to help with scene graph traversal caching operations.

Implements SoElement.

## ◆ getUnitData()

SoMultiTextureCoordinateElement::UnitData & SoMultiTextureCoordinateElement::getUnitData | ( | const int | unit | ) |
| protected

Returns the per-unit data for this element.

The documentation for this class was generated from the following files:

- SoMultiTextureCoordinateElement.h
- SoMultiTextureCoordinateElement.cpp